<template>
  <div class="board-outer border shadow">
    <div class="board-inner">
      <div class="column" v-for="diceValue in diceValues" :key="diceValue">
        <div
          class="square border"
          :class="{ complete: columnComplete(diceValue) }"
          v-for="(_, index) in Array(squareCount(diceValue))"
          :key="`${diceValue}:${index}`"
          :style="`grid-row: ${index + 1};`"
        >
          <span class="column-dice-value" v-if="index === 0">
            {{ diceValue }}
          </span>
        </div>

        <div
          v-for="(player, playerIndex) in state.players"
          :key="player.id"
          class="cone"
          :class="{
            top: player.cones[diceValue] === squareCount(diceValue),
            [`player-${playerIndex}`]: true,
          }"
          :style="`grid-row: ${
            squareCount(diceValue) - (player.cones[diceValue] ?? 0) + 1
          };`"
        >
          <player-icon
            :player-id="player.id"
            :players="state.players"
            v-if="player.cones[diceValue] !== undefined"
          />
        </div>

        <transition name="climb">
          <div
            class="runner"
            v-if="state.runners[diceValue] !== undefined"
            :style="`
            --runner-row: ${
              (activePlayer?.cones[diceValue] ?? 0) +
              state.runners[diceValue] -
              1
            };
            `"
          >
            <img :src="whiteRingImgSrc" />
          </div>
        </transition>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType } from "vue";
import whiteRingImgSrc from "../assets/white-ring.svg";
import PlayerIcon from "./PlayerIcon.vue";

const squareCounts: Record<number, number> = {
  2: 3,
  3: 5,
  4: 7,
  5: 9,
  6: 11,
  7: 13,
  8: 11,
  9: 9,
  10: 7,
  11: 5,
  12: 3,
};

export default defineComponent({
  name: "board",
  components: { PlayerIcon },
  props: {
    state: { type: Object as PropType<GameState>, required: true },
  },
  methods: {
    squareCount(diceValue: number) {
      return squareCounts[diceValue];
    },
    columnPlayers(diceValue: number) {
      return this.state.players.filter((p) => p.cones[diceValue] !== undefined);
    },
    columnComplete(diceValue: number): boolean {
      return this.state.players.some(
        (p) => p.cones[diceValue] >= squareCounts[diceValue]
      );
    },
  },
  data() {
    return {
      diceValues: [2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12],
      whiteRingImgSrc,
    };
  },
  computed: {
    activePlayer(): Player | undefined {
      return this.state.players.find((p) => p.id === this.state.phase.player);
    },
  },
});
</script>

<style lang="scss" scoped>
.board-outer {
  border-radius: 25%;
  padding: 1em;
  background-color: rgb(247, 226, 206);
  transform: rotate(45deg);
}
.board-inner {
  display: flex;
  transform: rotate(-45deg);
}

.column {
  margin: auto;
  display: grid;
  justify-content: center;
  align-items: center;
  position: relative;
}

.complete .column-dice-value {
  visibility: hidden;
}

.runner {
  --climb: 0;
  position: absolute;
  height: 2em;
  width: 2em;
  bottom: 0;
  left: 50%;
  transform: translateX(-50%) translateY(calc(var(--runner-row) * -100%))
    scale(120%) translateY(var(--climb));
  transition: transform 0.5s, opacity 0.5s;

  filter: drop-shadow(0.05em 0.05em 0.05em #222);
}

.climb-enter-active,
.climb-leave-active {
  --climb: 0;
  opacity: 100%;
}

.climb-enter-from,
.climb-leave-to {
  --climb: 200%;
  opacity: 0;
}

.cone {
  display: grid;
  place-content: center;
  grid-column: 1;
  font-size: 0.75em;
  &.player-0 {
    transform: translate(-0.5em, -0.5em);
  }
  &.player-1 {
    transform: translate(0.5em, -0.5em);
  }
  &.player-2 {
    transform: translate(-0.5em, 0.5em);
  }
  &.player-3 {
    transform: translate(0.5em, 0.5em);
  }
}
.cone.top {
  transform: none;
  font-size: 1.5em;
}

.square {
  height: 1.6em;
  width: 1.6em;
  margin: 0.2em 0.33em;
  border-color: rgba(0 0 0 / 0.25);

  &.complete:not(:first-child) {
    border-color: rgba(0 0 0 / 0.08);
  }

  color: rgba(0 0 0 / 0.35);
  font-weight: bold;

  display: flex;
  align-items: baseline;
  justify-content: center;
  grid-column: 1;
}
</style>
